#!/bin/bash

# number of /dev/rfcomm
DEVRFCOMM=""

#loop flag
LOOP=0

RUNFLAG=0

SCRIPTFILE=""

#mac addr accepted from remote device
MACADDR=""

#tarrget mac addr (from cmd line)
MACADDRPARAM=""


printhelp()
{
    echo "Usage:"
    echo "  "$0"                                                  show this help"
    echo "  "$0" -l                                               monitoring all devices"
    echo "  "$0" -m 11:22:33:44:55:66 -f <script>                 wait connect and execute script (once) and exit"
    echo "  "$0" -d <device> -m 11:22:33:44:55:66 -r -f <script>  not for interactive use"
}


#send/recive data to device
iodata()
{
    #stty -F $1 cs8 38400 ignbrk -brkint -icrnl -imaxbel -opost -onlcr -isig -icanon -iexten -echo -echoe -echok -echoctl -echoke noflsh -ixon raw
    echo -n "***"
    date
    #read incomming data form remote
    while true; do
	read -t 1 line
	if [ $? -gt 128 ]
	    then
		break
	    
	fi
	echo -e "\e[32m"$line"\033[0m"
	logger $MACADDR" "$line
    done < $1
    #send script to remote device
    echo "" > $1
    if [ "$SCRIPTFILE" != "" ] && [ "$MACADDRPARAM" = "$MACADDR" ]
    then
	while read line; do
	    echo $line > $1;
	done < $SCRIPTFILE
    fi
    echo "quit" > $1
    #read incomming data form remote
    while true; do
	read -t 1 line
	if [ $? -gt 128 ]
	    then
		break
	fi
	echo -e "\e[32m"$line"\033[0m";
	logger $MACADDR" "$line
    done < $1
    echo "Session end success"
}


#find free /dev/refcomm number
finddevrfcomm()
{
    for n in 1 2 3 4 5 6 7 8 9
    do
	FF="/dev/rfcomm"$n
	echo -n $FF
	if [ -e "$FF" ]
	then
	    echo " exist"
	else
	    echo " not exist"
	    DEVRFCOMM=$FF
	    break
	fi
    done
}


#get MAC from "rfcomm show"
getmac()
{
    DEVINDEX=${DEVRFCOMM/\/dev\/rfcomm/}
    MACADDR=`rfcomm show $DEVINDEX`
    N=`expr index "$MACADDR" ">"`
    MACADDR=${MACADDR:N+1}
    N=`expr index "$MACADDR" " "`
    MACADDR=${MACADDR:0:N-1}
}


# parse command line
parseargs()
{
    echo "["$@"]"
    if [ $# -eq 0 ]
	then
	    echo "missing args"
	    printhelp
	    exit 0
    fi
    while getopts "lrm:f:d:" Option
    do
	case $Option in
	    l	)	LOOP=1;;
	    r	)	RUNFLAG=1;;
	    f	)	SCRIPTFILE=$OPTARG;;
	    d	)	DEVRFCOMM=$OPTARG;;
	    m	)	MACADDRPARAM=$OPTARG;;
	    *	)	echo "uknown key"
			printhelp
			exit $E_OPTERROR;;   # ПО-УМОЛЧАНИЮ
	esac
    done
    shift $(($OPTIND - 1))

    echo "LOOP="$LOOP
    echo "SCRIPTFILE="$SCRIPTFILE
    echo "DEVRFCOMM="$DEVRFCOMM
    echo "RUNFLAG="$RUNFLAG
    echo "MACADDRPARAM="$MACADDRPARAM
}

# *****************
# ===== START =====
# *****************

parseargs $@

if [ "$RUNFLAG" = 1 ]
    then
	echo "PARAMS="$@
	getmac
	iodata $DEVRFCOMM
    else
	finddevrfcomm
	echo "select device "$DEVRFCOMM
	sdptool add --channel=3 SP
	rfcomm release $DEVRFCOMM
	#rfcomm bind /dev/rfcomm8 20:16:03:21:94:90 3

	# Accept incoming connections (in background) /dev/rfcomm0 channel3
	###rfcomm -r watch $DEVRFCOMM 3 ./send.sh {}
	while true
	do
	    PARAMS="-r"
	    if [ "$SCRIPTFILE" != "" ]
		then
		    PARAMS=$PARAMS" -f "$SCRIPTFILE
	    fi
	    if [ "$MACADDRPARAM" != "" ]
		then
		    PARAMS=$PARAMS" -m "$MACADDRPARAM
	    fi
	    rfcomm -r listen $DEVRFCOMM 3 $0 -d {} $PARAMS
	    if [ "$LOOP" = 0 ]
		then
		    break
	    fi
	    echo "Sleepping 10..."
	    sleep 10
	done
fi

